unit CavU2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Auto: TButton;
    Quit: TButton;
    GroupBox1: TGroupBox;
    SpinEdit1: TSpinEdit;
    Hasard: TButton;
    PasAPas: TButton;
    Clear: TButton;
    ButtTore: TButton;
    procedure FormCreate(Sender: TObject);
    procedure AutoClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure SpinEdit1Change(Sender: TObject);
    procedure HasardClick(Sender: TObject);
    procedure PasAPasClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure ButtToreClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

CONST C:CHAR='';

TYPE Plateau=ARRAY[0..61,0..61] OF SHORTINT;

VAR N:BYTE;
    A,B:Plateau;
    NCell:WORD;
    First,Pas,Tore:BOOLEAN;

PROCEDURE DessineGrille(N:BYTE);//redimensionne la grille
VAR i,j:SHORTINT;
    T,T2:BYTE;
begin
Form1.StringGrid1.Visible:=FALSE;
T:=10;
WITH Form1 DO
  BEGIN
  T2:=T+2*StringGrid1.GridLineWidth;
  WIDTH:=194+N*T2;
  IF 50+N*T2<364 THEN HEIGHT:=364
  ELSE HEIGHT:=50+N*T2;
  StringGrid1.RowCount:=N;
  StringGrid1.ColCount:=N;
  StringGrid1.Top:=(Form1.Height-(T2*N)) DIV 2-15;
  StringGrid1.Left:=164;//139+ROUND((Form1.Width-128-(T2*N))/2);
  StringGrid1.Height:=N*T2;//StringGrid1.DefaultRowHeight+ROUND(5+N*3*StringGrid1.GridLineWidth/2);
  StringGrid1.DefaultColWidth:=ROUND(StringGrid1.Height/N)-3;
  StringGrid1.DefaultRowHeight:=StringGrid1.DefaultColWidth;
  IF First THEN StringGrid1.Height:=StringGrid1.Height+9;
  StringGrid1.Width:=StringGrid1.Height;
  FOR i:=1 TO N DO
    FOR j:=1 TO N DO
      StringGrid1.Cells[j-1,i-1]:='';
  END;
Form1.StringGrid1.Visible:=TRUE;
First:=FALSE;
end;

FUNCTION F(i:BYTE):BYTE;//les bords se rejoignent
BEGIN
IF i=0 THEN F:=N
ELSE IF i=N+1 THEN F:=1
     ELSE F:=i
END;

PROCEDURE Voisins(i,j:BYTE;T:SHORTINT);//ajoute ou enlve un voisin
VAR l,c:BYTE;
BEGIN
IF Tore THEN
BEGIN
B[f(i-1),f(j-1)]:=B[f(i-1),f(j-1)]+T;B[f(i-1),f(j)]:=B[f(i-1),f(j)]+T;B[f(i-1),f(j+1)]:=B[f(i-1),f(j+1)]+T;
B[f(i)  ,f(j-1)]:=B[f(i  ),f(j-1)]+T;                                ;B[f(i)  ,f(j+1)]:=B[f(i)  ,f(j+1)]+T;
B[f(i+1),f(j-1)]:=B[f(i+1),f(j-1)]+T;B[f(i+1),f(j)]:=B[f(i+1),f(j)]+T;B[f(i+1),f(j+1)]:=B[f(i+1),f(j+1)]+T;
END//au dpart pour voir ce qui tait le + rapide: boucle ou numration. C'est la ^m chose!
ELSE BEGIN
     FOR l:=i-1 TO i+1 DO
       FOR c:=j-1 TO j+1 DO
         B[l,c]:=B[l,c]+T;
     B[i,j]:=B[i,j]-T;
     END;
END;

PROCEDURE DoIt;
// mort: si une cellule vivante a moins de 2 voisins ou plus de 3 voisins, elle meurt
// survie: une cellule survit si elle a exactement 2 ou 3 voisins
// naissance: si une case vide a exactement 3 voisins, une cellule nait  cet endroit
// Dans tous les autres cas, la cellule reste vide si elle l'tait.

VAR i,j,Mvt:WORD;
    V:Plateau;
    GridTmp:TStringGrid;
BEGIN
REPEAT
GridTmp:=Form1.StringGrid1;
Mvt:=0;
V:=B;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    IF A[i,j]=0 THEN IF V[i,j]=3 THEN BEGIN
                                      A[i,j]:=1;
                                      Voisins(i,j,+1);
                                      GridTmp.Cells[j-1,i-1]:=C;
                                      INC(NCell);
                                      INC(Mvt);
                                      END
                     ELSE
    ELSE IF (V[i,j]=2) OR (V[i,j]=3) THEN
         ELSE BEGIN
              A[i,j]:=0;
              Voisins(i,j,-1);
              GridTmp.Cells[j-1,i-1]:='';
              DEC(NCell);
              INC(Mvt);
              END;
Form1.StringGrid1:=GridTmp;
Application.ProcessMessages;
UNTIL (NCEll=0) OR (Mvt=0) OR Pas
END;

procedure TForm1.FormCreate(Sender: TObject);
begin
First:=TRUE;Tore:=FALSE;
N:=SpinEdit1.Value;
end;

procedure TForm1.AutoClick(Sender: TObject);//volution automatique
begin
Pas:=FALSE;
DoIt
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
CLOSE
end;

PROCEDURE InitA;
//remplissage alatoire. Je suis d'accord pour dire que cette procdure n'est pas terrible mais...
VAR i,j,k,M:WORD;
BEGIN
NCell:=0;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    A[i,j]:=0;B[i,j]:=0;
    Form1.StringGrid1.Cells[j-1,i-1]:='';
    END;
FOR i:=0 TO N+1 DO
  BEGIN
  A[i,0]:=0;B[i,0]:=0;
  A[i,N+1]:=0;B[i,N+1]:=0;
  A[0,i]:=0;B[0,i]:=0;
  A[N+1,i]:=0;B[N+1,i]:=0;
  END;
M:=N+RANDOM((N*N) DIV 3);
FOR k:=1 TO M DO
  BEGIN
  i:=1+RANDOM(N);
  j:=1+RANDOM(N);
  IF A[i,j]=0 THEN BEGIN
                   INC(NCell);
                   Voisins(i,j,+1);
                   A[i,j]:=1;
                   Form1.StringGrid1.Cells[j-1,i-1]:=C;
                   Application.ProcessMessages;
                   END;
  END;
END;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
//remplissage  la souris
VAR IL,IC:BYTE;
BEGIN
IL:=ARow+1;
IC:=ACol+1;
IF A[IL,IC]=1 THEN BEGIN
                   Form1.StringGrid1.Cells[IC-1,IL-1]:='';
                   Voisins(IL,IC,-1);
                   A[IL,IC]:=0;
                   DEC(NCell);
                   END
ELSE BEGIN
     Form1.StringGrid1.Cells[IC-1,IL-1]:=C;
     A[IL,IC]:=1;
     Voisins(IL,IC,+1);
     INC(NCell);
     END;
Application.ProcessMessages;
END;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
N:=SpinEdit1.Value;
DessineGrille(SpinEdit1.Value);
First:=FALSE;
NCell:=0;
end;

procedure TForm1.HasardClick(Sender: TObject);//remplissage au hasard
begin
N:=SpinEdit1.Value;
InitA;
end;

procedure TForm1.PasAPasClick(Sender: TObject);//volution pas--pas
begin
Pas:=TRUE;
DoIt
end;

procedure TForm1.ClearClick(Sender: TObject);//efface la grille
VAR i,j:WORD;
BEGIN
NCEll:=0;Tore:=FALSE;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    A[i,j]:=0;B[i,j]:=0;
    Form1.StringGrid1.Cells[j-1,i-1]:='';
    END;
end;

procedure TForm1.ButtToreClick(Sender: TObject);//les bords du tableau se rejoignent
begin
Tore:=TRUE
end;

end.
